(function($){

	$.fn.flow = function(options){

		var searchPhase = function(tree,id){
			for(var i = 0; i < tree.length; i++){
				if(id == tree[i]["id"]){
					return i;
				}
			}
		}

		var testPhases = function(array,tree, id){
			
			if(tree[id]["subphase"] != null){
				for(var i = 0; i < tree[id]["subphase"].length; i++){
					array.push(tree[id]["subphase"][i]);
					var index = searchPhase(tree, array[array.length-1]) ;
					testPhases(array, tree, index);
				}
			} 
		}

		var init = function(){
			var colorDefault = "#CCCCCC";
			var element = $(this);
			var settings = $.extend({
				"tree": [
					{
						"id": 1,
						"text" : "VocÃª ainda nÃ£o montou sua Ã¡rvore de decisÃ£o.",
						"subphase" : [2,3]
					},
					{
						"id": 2,
						"text" : "Resposta do sim.",
						"subphase" : null,
						"background" : "blue",
						"color": "font-white"
					},
					{
						"id": 3,
						"text" : "Resposta do não.",
						"subphase" : null,
						"background" : "red",
						"color": "font-white"
					}
				],
				"div_container": "row",
				"div_content_solo": "col s12",
				"div_content_btn": "col s10 align-middle",
				"div_btn": "col s2 align-middle",
				"btn" : "waves-effect waves-button waves-light waves-float"
			}, options);

			var buildPhase = function(id){
				var index = searchPhase(settings["tree"],id);

				var c_ner = $("<div id='flow_"+id+"'></div>").appendTo(element).addClass(settings["div_container"]).addClass("flow-container");
				var c_tent = $("<div></div>").appendTo(c_ner).addClass(settings["div_content_solo"]);
				var c_anim = $("<div></div>").appendTo(c_tent).addClass("caixa-anime");
				var p = $("<p></p>").appendTo(c_anim).html(settings["tree"][index]["text"]);

				if(settings["tree"][index]["background"]){
					c_anim.addClass(settings["tree"][index]["background"]);
				}

				if(settings["tree"][index]["color"]){
					p.addClass(settings["tree"][index]["color"]);
				}
					
				if(settings["tree"][index]["subphase"] != null){
					var c_btn = $("<div></div>").appendTo(c_ner).addClass(settings["div_btn"]);
					c_tent.removeClass(settings["div_content_solo"]).addClass(settings["div_content_btn"])
					var btn_yes = $("<div class='"+settings["btn"]+" btn_flow' data-nextid='"+settings["tree"][index]["subphase"][0]+"'>Sim</div>").appendTo(c_btn);
					var btn_no = $("<div class='"+settings["btn"]+" btn_flow'' data-nextid='"+settings["tree"][index]["subphase"][1]+"'>Não</div>").appendTo(c_btn);
					btn_yes.css({width: "100%", marginTop: "4px"}).on("click.flow", onBtnClick);
					btn_no.css({width: "100%", marginTop: "4px"}).on("click.flow", onBtnClick);
				}
			}

			var destroyPhases = function(element){
				var id = element.parents(".flow-container").attr("id");
				var arrayRemove = new Array(); 
				id = id.substring(5,6);
				id = Number(id);
				var index = searchPhase(settings["tree"],id);
				testPhases(arrayRemove, settings["tree"], index);

				for(var i = 0; i < arrayRemove.length; i++){
					var actualPhase = $("#flow_" + arrayRemove[i]);
					actualPhase.remove();
				}

			}

			var onBtnClick = function(){
				var father = $(this).parents(".flow-container").attr("id");
				father = $("#"+father);
				father.find(".btn_flow").css({opacity:"1"});
				$(this).css({opacity: "0.5"});
				destroyPhases($(this));
				var id = $(this).data("nextid");
				buildPhase(id);
			}


			buildPhase(1);
		}

		return this.each(init);
	}

})(jQuery);